Open Lighting Architecture: ola::plugin::usbpro::RobeWidget Class Reference

| Open Lighting Architecture 0.10.9

Loading...
Searching...
No Matches
Public Member Functions | Friends | List of all members
ola::plugin::usbpro::RobeWidget Class Reference
Inheritance diagram for ola::plugin::usbpro::RobeWidget:

## Public Member Functions
| RobeWidget (ola::io::ConnectedDescriptor *descriptor, const ola::rdm::UID &uid, unsigned int queue_size=20)
void | Stop ()
ola::io::ConnectedDescriptor * | GetDescriptor () const
bool | SendDMX (const DmxBuffer &buffer)
void | SendRDMRequest (ola::rdm::RDMRequest *request, ola::rdm::RDMCallback *on_complete)
| Send a RDM command.
void | RunFullDiscovery (ola::rdm::RDMDiscoveryCallback *callback)
| Start a full discovery operation.
void | RunIncrementalDiscovery (ola::rdm::RDMDiscoveryCallback *callback)
| Start an incremental discovery operation.
bool | ChangeToReceiveMode ()
void | SetDmxCallback (Callback0< void > *callback)
const DmxBuffer & | FetchDMX ()

## Friends
class | ::RobeWidgetTest

## Constructor & Destructor Documentation

## ◆ RobeWidget()

ola::plugin::usbpro::RobeWidget::RobeWidget | ( | ola::io::ConnectedDescriptor * | descriptor,
|  | const ola::rdm::UID & | uid,
|  | unsigned int | queue_size = 20 )

RobeWidget Constructor

## Member Function Documentation

## ◆ GetDescriptor()

ola::io::ConnectedDescriptor * ola::plugin::usbpro::RobeWidget::GetDescriptor | ( |  | ) | const
| inlinevirtual

Implements ola::plugin::usbpro::SerialWidgetInterface.

## ◆ RunFullDiscovery()

void ola::plugin::usbpro::RobeWidget::RunFullDiscovery | ( | ola::rdm::RDMDiscoveryCallback * | callback | ) |
| inlinevirtual

Start a full discovery operation.

Parameters

  callback | The callback run when discovery completes. This may run immediately in some implementations.

Implements ola::rdm::DiscoverableRDMControllerInterface.

## ◆ RunIncrementalDiscovery()

void ola::plugin::usbpro::RobeWidget::RunIncrementalDiscovery | ( | ola::rdm::RDMDiscoveryCallback * | callback | ) |
| inlinevirtual

Start an incremental discovery operation.

Parameters

  callback | The callback run when discovery completes. This may run immediately in some implementations.

Implements ola::rdm::DiscoverableRDMControllerInterface.

## ◆ SendRDMRequest()

void ola::plugin::usbpro::RobeWidget::SendRDMRequest | ( | ola::rdm::RDMRequest * | request,
|  | ola::rdm::RDMCallback * | on_complete )
| inlinevirtual

Send a RDM command.

Parameters

  request | the RDMRequest, ownership is transferred.
  on_complete | The callback to run when the request completes.

Implementors much ensure that the callback is always run at some point. In other words, there must be no way that a request can be dropped in such a way that the callback is never run. Doing so will either block all subsequent requests, or leak memory depending on the implementation.

Also the implementor of this class may want to re-write the transaction #, and possibly the UID (changing src UIDs isn't addressed by the RDM spec).

The RDMRequest may be a DISCOVERY_COMMAND, if the implementation does not support DISCOVERY_COMMANDs then the callback should be run with ola::rdm::RDM_PLUGIN_DISCOVERY_NOT_SUPPORTED.

Implements ola::rdm::RDMControllerInterface.

## ◆ Stop()

void ola::plugin::usbpro::RobeWidget::Stop | ( |  | ) |
| inlinevirtual

Implements ola::plugin::usbpro::SerialWidgetInterface.

The documentation for this class was generated from the following files:

- plugins/usbpro/RobeWidget.h
- plugins/usbpro/RobeWidget.cpp